Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmort.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmort.F90	(revision 12536)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmort.F90	(revision 12537)
@@ -20,12 +20,12 @@
    PRIVATE
 
-   PUBLIC   p4z_mort    
-   PUBLIC   p4z_mort_init    
-
-   REAL(wp), PUBLIC ::   wchln    !:
-   REAL(wp), PUBLIC ::   wchld    !:
-   REAL(wp), PUBLIC ::   wchldm   !:
-   REAL(wp), PUBLIC ::   mpratn   !:
-   REAL(wp), PUBLIC ::   mpratd   !:
+   PUBLIC   p4z_mort           ! Called from p4zbio.F90 
+   PUBLIC   p4z_mort_init      ! Called from trcini_pisces.F90 
+
+   REAL(wp), PUBLIC ::   wchln    !: Quadratic mortality rate of nanophytoplankton
+   REAL(wp), PUBLIC ::   wchld    !: Quadratic mortality rate of diatoms
+   REAL(wp), PUBLIC ::   wchldm   !: Maximum quadratic mortality rate of diatoms
+   REAL(wp), PUBLIC ::   mpratn   !: Linear mortality rate of nanophytoplankton
+   REAL(wp), PUBLIC ::   mpratd   !: Linear mortality rate of diatoms
 
    !!----------------------------------------------------------------------
@@ -40,5 +40,5 @@
       !!                     ***  ROUTINE p4z_mort  ***
       !!
-      !! ** Purpose :   Calls the different subroutine to initialize and compute
+      !! ** Purpose :   Calls the different subroutine to compute
       !!                the different phytoplankton mortality terms
       !!
@@ -49,5 +49,4 @@
       !
       CALL p4z_nano            ! nanophytoplankton
-      !
       CALL p4z_diat            ! diatoms
       !
@@ -82,17 +81,19 @@
                !     to 0
                zsizerat = MIN(1., MAX( 0., (quotan(ji,jj,jk) - 0.2) / 0.3) ) * trb(ji,jj,jk,jpphy)
-               !     Squared mortality of Phyto similar to a sedimentation term during
-               !     blooms (Doney et al. 1996)
+
+               ! Quadratic mortality of nano due to aggregation during
+               ! blooms (Doney et al. 1996)
+               ! -----------------------------------------------------
                zrespp = wchln * 1.e6 * xstep * xdiss(ji,jj,jk) * zcompaph * zsizerat 
 
-               !     Phytoplankton mortality. This mortality loss is slightly
-               !     increased when nutrients are limiting phytoplankton growth
-               !     as observed for instance in case of iron limitation.
+               ! Phytoplankton linear mortality
+               ! A michaelis-menten like term is introduced to avoid 
+               ! extinction of nanophyto in highly limited areas
+               ! ----------------------------------------------------
                ztortp = mpratn * xstep * zcompaph / ( xkmort + trb(ji,jj,jk,jpphy) ) * zsizerat
 
                zmortp = zrespp + ztortp
 
-               !   Update the arrays TRA which contains the biological sources and sinks
-
+               ! Update the arrays TRA which contains the biological sources and sinks
                zfactfe = trb(ji,jj,jk,jpnfe)/(trb(ji,jj,jk,jpphy)+rtrn)
                zfactch = trb(ji,jj,jk,jpnch)/(trb(ji,jj,jk,jpphy)+rtrn)
@@ -100,8 +101,7 @@
                tra(ji,jj,jk,jpnch) = tra(ji,jj,jk,jpnch) - zmortp * zfactch
                tra(ji,jj,jk,jpnfe) = tra(ji,jj,jk,jpnfe) - zmortp * zfactfe
+               ! Production PIC particles due to mortality
                zprcaca = xfracal(ji,jj,jk) * zmortp
-               !
                prodcal(ji,jj,jk) = prodcal(ji,jj,jk) + zprcaca  ! prodcal=prodcal(nanophy)+prodcal(microzoo)+prodcal(mesozoo)
-               !
                zfracal = 0.5 * xfracal(ji,jj,jk)
                tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) - zprcaca
@@ -146,8 +146,8 @@
       IF( ln_timing )   CALL timing_start('p4z_diat')
       !
-      !    Aggregation term for diatoms is increased in case of nutrient
-      !    stress as observed in reality. The stressed cells become more
-      !    sticky and coagulate to sink quickly out of the euphotic zone
-      !     ------------------------------------------------------------
+      ! Aggregation term for diatoms is increased in case of nutrient
+      ! stress as observed in reality. The stressed cells become more
+      ! sticky and coagulate to sink quickly out of the euphotic zone
+      ! -------------------------------------------------------------
 
       DO jk = 1, jpkm1
@@ -157,21 +157,21 @@
                zcompadi = MAX( ( trb(ji,jj,jk,jpdia) - 1e-9), 0. )
 
-               !    Aggregation term for diatoms is increased in case of nutrient
-               !    stress as observed in reality. The stressed cells become more
-               !    sticky and coagulate to sink quickly out of the euphotic zone
-               !     ------------------------------------------------------------
-               !  Phytoplankton respiration 
-               !     ------------------------
+               ! Aggregation term for diatoms is increased in case of nutrient
+               ! stress as observed in reality. The stressed cells become more
+               ! sticky and coagulate to sink quickly out of the euphotic zone
+               ! ------------------------------------------------------------
                zlim2   = xlimdia(ji,jj,jk) * xlimdia(ji,jj,jk)
                zlim1   = 0.25 * ( 1. - zlim2 ) / ( 0.25 + zlim2 ) 
                zrespp2 = 1.e6 * xstep * (  wchld + wchldm * zlim1 ) * xdiss(ji,jj,jk) * zcompadi * trb(ji,jj,jk,jpdia)
 
-               !     Phytoplankton mortality. 
-               !     ------------------------
+               ! Phytoplankton linear mortality
+               ! A michaelis-menten like term is introduced to avoid 
+               ! extinction of diatoms in highly limited areas
+               !  ---------------------------------------------------
                ztortp2 = mpratd * xstep * trb(ji,jj,jk,jpdia)  / ( xkmort + trb(ji,jj,jk,jpdia) ) * zcompadi 
 
                zmortp2 = zrespp2 + ztortp2
 
-               !   Update the arrays tra which contains the biological sources and sinks
+               ! Update the arrays tra which contains the biological sources and sinks
                !   ---------------------------------------------------------------------
                zfactch = trb(ji,jj,jk,jpdch) / ( trb(ji,jj,jk,jpdia) + rtrn )
@@ -210,8 +210,8 @@
       !! ** Purpose :   Initialization of phytoplankton parameters
       !!
-      !! ** Method  :   Read the nampismort namelist and check the parameters
+      !! ** Method  :   Read the namp4zmort namelist and check the parameters
       !!              called at the first timestep
       !!
-      !! ** input   :   Namelist nampismort
+      !! ** input   :   Namelist namp4zmort
       !!
       !!----------------------------------------------------------------------
@@ -227,8 +227,8 @@
       ENDIF
       !
-      REWIND( numnatp_ref )              ! Namelist nampismort in reference namelist : Pisces phytoplankton
+      REWIND( numnatp_ref )              ! Namelist namp4zmort in reference namelist : Pisces phytoplankton
       READ  ( numnatp_ref, namp4zmort, IOSTAT = ios, ERR = 901)
 901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namp4zmort in reference namelist' )
-      REWIND( numnatp_cfg )              ! Namelist nampismort in configuration namelist : Pisces phytoplankton
+      REWIND( numnatp_cfg )              ! Namelist namp4zmort in configuration namelist : Pisces phytoplankton
       READ  ( numnatp_cfg, namp4zmort, IOSTAT = ios, ERR = 902 )
 902   IF( ios >  0 )   CALL ctl_nam ( ios , 'namp4zmort in configuration namelist' )
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zpoc.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zpoc.F90	(revision 12536)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zpoc.F90	(revision 12537)
@@ -3,4 +3,5 @@
    !!                         ***  MODULE p4zpoc  ***
    !! TOP :   PISCES Compute remineralization of organic particles
+   !!         Same module for both PISCES and PISCES-QUOTA
    !!=========================================================================
    !! History :   1.0  !  2004     (O. Aumont) Original code
@@ -8,7 +9,9 @@
    !!             3.4  !  2011-06  (O. Aumont, C. Ethe) Quota model for iron
    !!             3.6  !  2016-03  (O. Aumont) Quota model and diverse
+   !!             4.0  !  2018     (O. Aumont) Variable lability parameterization
    !!----------------------------------------------------------------------
    !!   p4z_poc       :  Compute remineralization/dissolution of organic compounds
    !!   p4z_poc_init  :  Initialisation of parameters for remineralisation
+   !!   alngam and gamain : computation of the incomplete gamma function
    !!----------------------------------------------------------------------
    USE oce_trc         !  shared variables between ocean and passive tracers
@@ -22,6 +25,6 @@
 
    PUBLIC   p4z_poc         ! called in p4zbio.F90
-   PUBLIC   p4z_poc_init    ! called in trcsms_pisces.F90
-   PUBLIC   alngam          !
+   PUBLIC   p4z_poc_init    ! called in trcini_pisces.F90
+   PUBLIC   alngam          ! 
    PUBLIC   gamain          !
 
@@ -33,6 +36,6 @@
    REAL(wp), PUBLIC ::   rshape     !: shape factor of the gamma distribution
 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)       ::   alphan, reminp   !:
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::   alphap           !:
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)       ::   alphan, reminp   !: variable lability of POC and initial distribution
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::   alphap           !: lability distribution of small particles
 
 
@@ -49,6 +52,13 @@
       !!
       !! ** Purpose :   Compute remineralization of organic particles
+      !!                A reactivity-continuum parameterization is chosen
+      !!                to describe the lability of the organic particles
+      !!                As a consequence, the remineralisation rates of the 
+      !!                the different pools change with time as a function of 
+      !!                the lability distribution
       !!
-      !! ** Method  : - ???
+      !! ** Method  : - Computation of the remineralisation rates is performed
+      !!                according to reactivity continuum formalism described
+      !!                in Aumont et al. (2017). 
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt, knt   ! ocean time step and ???
@@ -79,5 +89,5 @@
       solgoc = 0.04/ 2.56 * 1./ ( 1.-50**(-0.04) )
 
-      ! Initialisation of temprary arrys
+      ! Initialisation of temporary arrys
       IF( ln_p4z ) THEN
          zremipoc(:,:,:) = xremip
@@ -92,4 +102,6 @@
       zfolimi (:,:,:) = 0.
 
+      ! Initialisation of the lability distributions that are set to 
+      ! the distribution of newly produced organic particles
       DO jn = 1, jcpoc
         alphag(:,:,:,jn) = alphan(jn)
@@ -97,8 +109,8 @@
       END DO
 
-     ! -----------------------------------------------------------------------
      ! Lability parameterization. This is the big particles part (GOC)
-     ! This lability parameterization can be activated only with the standard
-     ! particle scheme. Does not work with Kriest parameterization.
+     ! This lability parameterization is always active. However, if only one
+     ! lability class is specified in the namelist, this is equivalent to 
+     ! a standard parameterisation with a constant lability
      ! -----------------------------------------------------------------------
      ztremint(:,:,:) = zremigoc(:,:,:)
@@ -108,9 +120,8 @@
               IF (tmask(ji,jj,jk) == 1.) THEN
                 zdep = hmld(ji,jj)
-                !
+
                 ! In the case of GOC, lability is constant in the mixed layer 
                 ! It is computed only below the mixed layer depth
                 ! ------------------------------------------------------------
-                !
                 IF( gdept_n(ji,jj,jk) > zdep ) THEN
                   alphat = 0.
@@ -153,9 +164,8 @@
                     END DO
                   ELSE
-                    !
+
                     ! standard algorithm in the rest of the water column
                     ! See the comments in the previous block.
                     ! ---------------------------------------------------
-                    !
                     zpoc = trb(ji,jj,jk-1,jpgoc) + consgoc(ji,jj,jk-1) * rday / rfact2               &
                     &   * e3t_n(ji,jj,jk-1) / 2. / (wsbio4(ji,jj,jk-1) + rtrn) + consgoc(ji,jj,jk)   &
@@ -192,9 +202,12 @@
 
       IF( ln_p4z ) THEN
+         ! The standard PISCES part
          DO jk = 1, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  ! POC disaggregation by turbulence and bacterial activity. 
-                  ! --------------------------------------------------------
+                  ! POC degradation by bacterial activity. It is a function 
+                  ! of the mean lability and of temperature. This also includes
+                  ! shrinking of particles due to the bacterial activity
+                  ! -----------------------------------------------------------
                   zremig = zremigoc(ji,jj,jk) * xstep * tgfunc(ji,jj,jk)
                   zorem2  = zremig * trb(ji,jj,jk,jpgoc)
@@ -204,5 +217,5 @@
                   zofer3 = zremig * solgoc * trb(ji,jj,jk,jpbfe)
 
-                  ! -------------------------------------
+                  ! update of the TRA arrays
                   tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zorem3(ji,jj,jk)
                   tra(ji,jj,jk,jpgoc) = tra(ji,jj,jk,jpgoc) - zorem2 - zorem3(ji,jj,jk)
@@ -216,9 +229,12 @@
          END DO
       ELSE
+         ! PISCES-QUOTA part
          DO jk = 1, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
-                   ! POC disaggregation by turbulence and bacterial activity. 
-                  ! --------------------------------------------------------
+                  ! POC disaggregation by bacterial activity. It is a function
+                  ! of the mean lability and of temperature. Shrinking of 
+                  ! particles due to the bacterial activity is also included 
+                  ! ----------------------------------------------------------
                   zremig = zremigoc(ji,jj,jk) * xstep * tgfunc(ji,jj,jk)
                   zopoc2 = zremig  * trb(ji,jj,jk,jpgoc)
@@ -229,5 +245,5 @@
                   zofer2 = xremipn / xremipc * zremig * trb(ji,jj,jk,jpbfe)
 
-                  ! -------------------------------------
+                  ! Update of the TRA arrays
                   tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zorem3(ji,jj,jk)
                   tra(ji,jj,jk,jppon) = tra(ji,jj,jk,jppon) + solgoc * zopon2 
@@ -254,18 +270,16 @@
      ENDIF
 
-     ! ------------------------------------------------------------------
      ! Lability parameterization for the small OM particles. This param 
      ! is based on the same theoretical background as the big particles.
      ! However, because of its low sinking speed, lability is not supposed
      ! to be equal to its initial value (the value of the freshly produced
-     ! organic matter). It is however uniform in the mixed layer.
-     ! -------------------------------------------------------------------
-     !
+     ! organic matter) in the MLD. It is however uniform in the mixed layer.
+     ! ---------------------------------------------------------------------
      totprod (:,:) = 0.
      totthick(:,:) = 0.
      totcons (:,:) = 0.
+
      ! intregrated production and consumption of POC in the mixed layer
      ! ----------------------------------------------------------------
-     ! 
      DO jk = 1, jpkm1
         DO jj = 1, jpj
@@ -284,5 +298,6 @@
 
      ! Computation of the lability spectrum in the mixed layer. In the mixed 
-     ! layer, this spectrum is supposed to be uniform.
+     ! layer, this spectrum is supposed to be uniform as a result of intense
+     ! mixing.
      ! ---------------------------------------------------------------------
      ztremint(:,:,:) = zremipoc(:,:,:)
@@ -318,5 +333,4 @@
      ENDIF
 
-     ! -----------------------------------------------------------------------
      ! The lability parameterization is used here. The code is here 
      ! almost identical to what is done for big particles. The only difference
@@ -325,5 +339,4 @@
      ! should be determined before.
      ! -----------------------------------------------------------------------
-     !
      DO jk = 2, jpkm1
         DO jj = 1, jpj
@@ -334,13 +347,11 @@
                   alphat = 0.
                   remint = 0.
-                  !
                   ! the scale factors are corrected with temperature
                   zsizek1  = e3t_n(ji,jj,jk-1) / 2. / (wsbio3(ji,jj,jk-1) + rtrn) * tgfunc(ji,jj,jk-1)
                   zsizek = e3t_n(ji,jj,jk) / 2. / (wsbio3(ji,jj,jk) + rtrn) * tgfunc(ji,jj,jk)
-                  !
+
                   ! Special treatment of the level just below the MXL
                   ! See the comments in the GOC section
                   ! ---------------------------------------------------
-                  !
                   IF ( gdept_n(ji,jj,jk-1) <= zdep ) THEN
                     !
@@ -362,10 +373,9 @@
                     END DO
                   ELSE
-                    !
+
                     ! Lability parameterization for the interior of the ocean
                     ! This is very similar to what is done in the previous 
                     ! block
                     ! --------------------------------------------------------
-                    !
                     zpoc = trb(ji,jj,jk-1,jppoc) + conspoc(ji,jj,jk-1) * rday / rfact2               &
                     &   * e3t_n(ji,jj,jk-1) / 2. / (wsbio3(ji,jj,jk-1) + rtrn) + conspoc(ji,jj,jk)   &
@@ -404,14 +414,17 @@
 
      IF( ln_p4z ) THEN
-         DO jk = 1, jpkm1
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  IF (tmask(ji,jj,jk) == 1.) THEN
-                    ! POC disaggregation by turbulence and bacterial activity. 
-                    ! --------------------------------------------------------
+        ! Standard PISCES part
+        DO jk = 1, jpkm1
+           DO jj = 1, jpj
+              DO ji = 1, jpi
+                 IF (tmask(ji,jj,jk) == 1.) THEN
+                    ! POC disaggregation by bacterial activity. It is a function
+                    ! of the mean lability and of temperature 
+                    ! ----------------------------------------------------------
                     zremip          = zremipoc(ji,jj,jk) * xstep * tgfunc(ji,jj,jk)
                     zorem           = zremip * trb(ji,jj,jk,jppoc)
                     zofer           = zremip * trb(ji,jj,jk,jpsfe)
 
+                    ! Update of the TRA arrays
                     tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) + zorem
                     orem(ji,jj,jk)      = orem(ji,jj,jk) + zorem
@@ -420,31 +433,33 @@
                     tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) - zofer
                     zfolimi(ji,jj,jk)   = zfolimi(ji,jj,jk) + zofer
-                  ENDIF
-               END DO
-            END DO
-         END DO
+                 ENDIF
+              END DO
+           END DO
+        END DO
      ELSE
-       DO jk = 1, jpkm1
-          DO jj = 1, jpj
-             DO ji = 1, jpi
-                ! POC disaggregation by turbulence and bacterial activity. 
-                ! --------------------------------------------------------
-                zremip = zremipoc(ji,jj,jk) * xstep * tgfunc(ji,jj,jk)
-                zopoc  = zremip * trb(ji,jj,jk,jppoc)
-                orem(ji,jj,jk)  = orem(ji,jj,jk) + zopoc
-                zopon  = xremipn / xremipc * zremip * trb(ji,jj,jk,jppon)
-                zopop  = xremipp / xremipc * zremip * trb(ji,jj,jk,jppop)
-                zofer  = xremipn / xremipc * zremip * trb(ji,jj,jk,jpsfe)
-
-                tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) - zopoc
-                tra(ji,jj,jk,jppon) = tra(ji,jj,jk,jppon) - zopon
-                tra(ji,jj,jk,jppop) = tra(ji,jj,jk,jppop) - zopop
-                tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) - zofer
-                tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) + zopoc
-                tra(ji,jj,jk,jpdon) = tra(ji,jj,jk,jpdon) + zopon 
-                tra(ji,jj,jk,jpdop) = tra(ji,jj,jk,jpdop) + zopop 
-                tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + zofer 
-                zfolimi(ji,jj,jk)   = zfolimi(ji,jj,jk) + zofer
-             END DO
+        ! PISCES QUOTA part
+        DO jk = 1, jpkm1
+           DO jj = 1, jpj
+              DO ji = 1, jpi
+                 ! POC disaggregation by bacterial activity. It is a function
+                 ! of the mean lability and of temperature 
+                 ! ----------------------------------------------------------
+                 zremip = zremipoc(ji,jj,jk) * xstep * tgfunc(ji,jj,jk)
+                 zopoc  = zremip * trb(ji,jj,jk,jppoc)
+                 orem(ji,jj,jk)  = orem(ji,jj,jk) + zopoc
+                 zopon  = xremipn / xremipc * zremip * trb(ji,jj,jk,jppon)
+                 zopop  = xremipp / xremipc * zremip * trb(ji,jj,jk,jppop)
+                 zofer  = xremipn / xremipc * zremip * trb(ji,jj,jk,jpsfe)
+
+                 tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) - zopoc
+                 tra(ji,jj,jk,jppon) = tra(ji,jj,jk,jppon) - zopon
+                 tra(ji,jj,jk,jppop) = tra(ji,jj,jk,jppop) - zopop
+                 tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) - zofer
+                 tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) + zopoc
+                 tra(ji,jj,jk,jpdon) = tra(ji,jj,jk,jpdon) + zopon 
+                 tra(ji,jj,jk,jpdop) = tra(ji,jj,jk,jpdop) + zopop 
+                 tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + zofer 
+                 zfolimi(ji,jj,jk)   = zfolimi(ji,jj,jk) + zofer
+              END DO
            END DO
         END DO
@@ -454,7 +469,7 @@
         IF( knt == nrdttrc ) THEN
           zrfact2 = 1.e3 * rfact2r
-          CALL iom_put( "REMINP" , zremipoc(:,:,:) * tmask(:,:,:) )  ! Remineralisation rate
-          CALL iom_put( "REMING" , zremigoc(:,:,:) * tmask(:,:,:) )  ! Remineralisation rate
-          CALL iom_put( "REMINF" , zfolimi(:,:,:)  * tmask(:,:,:)  * 1.e+9 * zrfact2 )  ! Remineralisation rate
+          CALL iom_put( "REMINP" , zremipoc(:,:,:) * tmask(:,:,:) )  ! Remineralisation rate of small particles
+          CALL iom_put( "REMING" , zremigoc(:,:,:) * tmask(:,:,:) )  ! Remineralisation rate of large particles
+          CALL iom_put( "REMINF" , zfolimi(:,:,:)  * tmask(:,:,:)  * 1.e+9 * zrfact2 )  ! Remineralisation of biogenic particulate iron
         ENDIF
      ENDIF
